BEGIN	{
#  $Header: /home/westiv/iorate/RCS/gen_sum.awk,v 3.1 2011/10/12 20:07:31 westiv Exp westiv $
	    FS = "\t" ; cur_test = 0 ;
	    skew_present = 0 ;
	}
/^test/		{
	    printf( "%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s", $1, $2, $5, $6, $7, $8, $9, $10 ) ;
	    printf( "\t%s\t%s\t%s\t%s\t%s\t%s\t%s", $11, $12, $13, $14, $15, $16, $17 ) ;
	    if ( NF > 20 ) {		# with skew data - 3 groups
		skew_present = 1;

		printf( "\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s", $19, $20, $21, $22, $23, $24, $25, $26 ) ;
		printf( "\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s", $27, $28, $29, $30, $32, $32, $33, $34 ) ;
		printf( "\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s", $35, $36, $37, $38, $39, $40, $41, $42 ) ;
	    };
	    printf( "\n" );
	    next ;
	}
/^[0-9]/	{
	    if ( cur_test == $1 ) {	# add to sum
		total_devs++ ;
		total_reads += $7 ;
		total_kb_read += $8 ;
		total_read_resp += $7 * $9;
		total_writes += $10 ;
		total_kb_written += $11 ;
		total_write_resp += $10 * $12 ;
		total_io += $13 ;
		total_kb += $14 ;
		total_resp += $7 * $9 + $10 * $12;

		if ( skew_present ) {
		    for ( skew = 0; skew < 12; skew++ ) {
			iops_rec = 19 + skew * 2 ;
			resp_rec = iops_rec + 1 ;
			skew_iops[ skew ] += $iops_rec ;
			skew_resp[ skew ] += $resp_rec  * $iops_rec ;
		    } ;
		};
	    } else {			# start new test - reset counts
		if ( cur_test > 0 ) {	# print totals if valid
		    total_iops = ( total_reads + total_writes ) / cur_meas_sec ;
		    total_kbps = ( total_kb_read + total_kb_written ) / cur_meas_sec ;

		    printf( "%d\t%s\t%d\t%d", cur_test, cur_name, cur_total_sec, cur_meas_sec ) ;
		    printf( "\t%d\t%d", total_reads, total_kb_read ) ;
		    if ( total_reads > 0 ) {
			printf( "\t%.2f", total_read_resp / total_reads ) ;
		    } else {
			printf( "\t0.0" ) ;
		    } ;
		    printf( "\t%d\t%d", total_writes, total_kb_written ) ;
		    if ( total_writes > 0 ) {
			printf( "\t%.2f", total_write_resp / total_writes ) ;
		    } else {
			printf( "\t0.0" ) ;
		    } ;
		    printf( "\t%d\t%d\t%.2f", total_io, total_kb, total_resp / ( total_reads + total_writes )) ;
		    printf( "\t%d\t%d", total_iops, total_kbps ) ;

		    if ( skew_present ) {
			for ( skew = 0; skew < 12; skew++ ) {
			    iops_rec = 19 + skew * 2 ;
			    resp_rec = iops_rec + 1 ;

			    printf( "\t%d", skew_iops[ skew ]) ;
			    if ( skew_iops[ skew ] > 0 ) {
				printf( "\t%.2f", skew_resp[ skew ]/ skew_iops[ skew ]) ;
			    } else {
				printf( "\t0.0" ) ;
			    } ;
			} ;
		    };

		    printf( "\n" ) ;
		} ;

		if ( $1 != cur_test + 1 ) { # SOMETHING IS WRONG
		    printf( "Bad test number after test %d (got %d)\n", cur_test, $1 ) ;
		};

		cur_test = $1 ;
		cur_name = $2 ;
		cur_total_sec = $5 ;
		cur_meas_sec = $6 ;
		total_devs = 1 ;
		total_reads = $7 ;
		total_kb_read = $8 ;
		total_read_resp = $7 * $9 ;
		total_writes = $10 ;
		total_kb_written = $11 ;
		total_write_resp = $10 * $12 ;
		total_io = $13 ;
		total_kb = $14 ;
		total_resp = $7 * $9 + $10 * $12;

		if ( skew_present ) {
		    for ( skew = 0; skew < 12; skew++ ) {
			iops_rec = 19 + skew * 2 ;
			resp_rec = iops_rec + 1 ;
			skew_iops[ skew ] = $iops_rec ;
			skew_resp[ skew ] = $resp_rec * $iops_rec ;
		    } ;
		};
	    } ;
	    next ;
	}
END	{	# Print total for last test
	    total_iops = ( total_reads + total_writes ) / cur_meas_sec ;
	    total_kbps = ( total_kb_read + total_kb_written ) / cur_meas_sec ;

	    printf( "%d\t%s\t%d\t%d", cur_test, cur_name, cur_total_sec, cur_meas_sec ) ;
	    printf( "\t%d\t%d", total_reads, total_kb_read ) ;
	    if ( total_reads > 0 ) {
		printf( "\t%.2f", total_read_resp / total_reads ) ;
	    } else {
		printf( "\t0.0" ) ;
	    } ;
	    printf( "\t%d\t%d", total_writes, total_kb_written ) ;
	    if ( total_writes > 0 ) {
		printf( "\t%.2f", total_write_resp / total_writes ) ;
	    } else {
		printf( "\t0.0" ) ;
	    } ;
	    printf( "\t%d\t%d\t%.2f", total_io, total_kb, total_resp / ( total_reads + total_writes )) ;
	    printf( "\t%d\t%d", total_iops, total_kbps ) ;

	    if ( skew_present ) {
		for ( skew = 0; skew < 12; skew++ ) {
		    iops_rec = 19 + skew * 2 ;
		    resp_rec = iops_rec + 1 ;

		    printf( "\t%d", skew_iops[ skew ]) ;
		    if ( skew_iops[ skew ] > 0 ) {
			printf( "\t%.2f", skew_resp[ skew ]/ skew_iops[ skew ]) ;
		    } else {
			printf( "\t0.0" ) ;
		    } ;
		} ;
	    };

	    printf( "\n" ) ;
	}
